<?php

  //forward all commands to right net function on open socket
  function net ($fp, $command, $password)
  {
    switch ($command)
    {
      //format protocol commands
      case "info":
        $result = net_protocol_info($fp, $command);
        break;

      case "players":
        $result = net_protocol_players($fp, $command);
        break;

      case "rules":
        $result = net_protocol_rules($fp, $command);
        break;

      case "details":
        $result = net_protocol_details($fp, $command);
        break;


      //per default execute all commands with rcon
      default:
        $result = net_rcon($fp, $command, $password);
        break;
    }
    
    return $result;
  } //function net ($fp, $command, $password)


  //Execute rcon command on open socket $fp
  function net_rcon ($fp, $command, $password)
  {
    fputs ($fp, "\xff\xff\xff\xffchallenge rcon\n");
    $buffer = net_get_int32($fp);
    
    $challengenr = net_get_word($fp);
    $challengenr = strtok($challengenr, " ");
    $challengenr = strtok(" ");
    $challengenr = trim(strtok(" "));

    fputs ($fp, "\xff\xff\xff\xffrcon $challengenr \"$password\" $command\n");
    $buffer = net_get_int32($fp);
    $result = net_get_word($fp);
    $result = substr($result, 1);
    
    return $result;
  } //function net_rcon ($fp, $password, $command)


  //Get protocol info on open socket $fp
  function net_protocol_info ($fp)
  {
    fputs ($fp, "\xff\xff\xff\xffinfo\x00");

    $buffer = net_get_int32($fp);
    $buffer = net_get_byte($fp);

    $result = net_get_word($fp) . "\n";
    $result .= net_get_word($fp) . "\n";
    $result .= net_get_word($fp) . "\n";
    $result .= net_get_word($fp) . "\n";
    $result .= net_get_word($fp) . "\n";
    $result .= net_get_byte($fp) . "\n";
    $result .= net_get_byte($fp) . "\n";
    $result .= net_get_byte($fp);

    return $result;
  } //function net_protocol_info ($fp)


  //Get protocol players on open socket $fp
  function net_protocol_players ($fp)
  {
    fputs($fp, "\xff\xff\xff\xffplayers\x00");

    $buffer = net_get_int32($fp);
    $buffer = net_get_byte($fp);
    
    $count = net_get_byte($fp);
    $result = "" . $count . "\n";

    for($i = 0; $i < $count; $i++)
    {
      $result .= net_get_byte($fp) . "\t";
      $result .= net_get_word($fp) . "\t";
      $result .= net_get_int32($fp) . "\t";
      $result .= net_get_int32($fp) . "\n";
    }
    
    return $result;
  } //function net_protocol_players ($fp)
  

  //Get protocol rules on open socket $fp
  function net_protocol_rules ($fp)
  {
    fputs($fp, "\xff\xff\xff\xffrules\x00");

    $buffer = net_get_int32($fp);
    $buffer = net_get_byte($fp);
    
    $count = net_get_int16($fp);
    $result = $count . "\n";
    
    for($i = 0; $i < $count; $i++)
    {
      $result .= net_get_word($fp). "\t";
      $result .= net_get_word($fp). "\n";
    }
    
    return $result;
  } //function net_protocol_rules ($fp)
  

  //Get protocol details on open socket $fp
  function net_protocol_details ($fp)
  {
    fputs($fp, "\xff\xff\xff\xffdetails\x00");

    $buffer = net_get_int32($fp);
    $buffer = net_get_byte($fp);
    
    $result = net_get_word($fp) . "\n";
    $result .= net_get_word($fp) . "\n";
    $result .= net_get_word($fp) . "\n";
    $result .= net_get_word($fp) . "\n";
    $result .= net_get_word($fp) . "\n";
    $result .= net_get_byte($fp) . "\n";
    $result .= net_get_byte($fp) . "\n";
    $result .= net_get_byte($fp) . "\n";
    $result .= net_get_byte($fp) . "\n";
    $result .= net_get_byte($fp) . "\n";
    $result .= net_get_byte($fp) . "\n";
    $mod = net_get_byte ($fp);
    $result .= $mod . "\n";

    if($mod == 1)
    {
      $result .= net_get_word($fp) . "\n";
      $result .= net_get_word($fp) . "\n";
      $result .= net_get_int32($fp) . "\n";
      $result .= net_get_int32($fp) . "\n";
      $result .= net_get_byte($fp) . "\n";
      $result .= net_get_byte($fp) . "\n";
    }
    
    return $result;
  } //function net_protocol_details ($fp)
  

  //Open UDP socket to server:port
  function net_connect ($tmpserver, $tmpport)
  {
    $fp = fsockopen ("udp://" . $tmpserver, $tmpport, &$errno, &$errstr, (double) 3);

    return $fp;
  } //function net_connect ($tmpserver, $tmpport)


  //Get single byte from socket
  function net_get_byte ($fp)
  {
    $buffer = fread ($fp, 1);
    
    return ord($buffer);
  } //function net_get_byte ($fp)


  //Get 2 byte integer from socket
  function net_get_int16 ($fp)
  {
    $buffer = ord(fread ($fp, 1));
    $buffer += ord(fread ($fp, 1)) << 8;
      
    return $buffer;
  } //function net_get_int32 ($fp)


  //Get 4 byte integer from socket
  function net_get_int32 ($fp)
  {
    $buffer = ord(fread ($fp, 1));
    $buffer += ord(fread ($fp, 1)) << 8;
    $buffer += ord(fread ($fp, 1)) << 16;
    $buffer += ord(fread ($fp, 1)) << 24;
      
    return $buffer;
  } //function net_get_int32 ($fp)


  //Get string from socket until break character \x00 or \n 
  function net_get_word ($fp)
  {
    $buffer= "";
    $byte = "\xff";
    while ($byte != "\x00")
    {
      $byte = fread ($fp, 1);
      $buffer .= $byte;
    }
    
    return $buffer;
  } //function net_get_word ($fp)

?>