<?php
  include("./config.php");
  include("./security.php");
  include("./rcon_net.php");

  //neues Template erzeugen
  include("./template.inc");
  $tpl = new Template($templatedir, "keep");

  //Files bekannt machen
  $tpl->set_file(array(
    "main" => "main.ihtml",
    "messages" => "messages.ihtml",
    "helptext" => "helptext.ihtml",
    "serverrules" => "serverrules.ihtml"
  ));
  
  //Blocks definieren
  $tpl->set_block("serverrules", "row", "ROWS");
  $tpl->set_block("messages", "notconnected", "NOTCONNECTED");
  $tpl->set_block("messages", "badrcon", "BADRCON");
  $tpl->set_block("helptext", "rules", "RULES");

  //parse helptext
  $tpl->set_var("TEMPLATEDIR", $templatedir);
  if($helptext == 1)
    $tpl->parse("HELP", "rules", false);
  else
    $tpl->set_var("HELP", "");


  //connect to current server
  $fp = net_connect($server_ip, $server_port);
  
  //Not connected error
  if(!$fp)
  {
    $tpl->parse("CONTENT", "notconnected", false);
    $tpl->parse("OUT", "main", false);
    $tpl->p("OUT");
    exit;
  }

  //send "rules" command to current server
  $rules = net($fp, "rules", $server_password);

  //close connection
  fclose($fp);


  //Do all output stuff
  $line = explode("\n", $rules);
  $count = sizeof($line);
  sort($line);

  for($i = 2; $i < $count; $i++)  
  {
    //get rule line
    $rule = explode("\t", $line[$i]);
    
    //toggle row color
    if($row == "row_one")
      $row = "row_two";
    else
      $row = "row_one";

    $tpl->set_var(array(
      "ROWSTYLE" => $row,
      "COMMAND" => urlencode(trim($rule[0]) . " " . trim($rule[1])),
      "RULE" => $rule[0],
      "VALUE" => $rule[1]
    ));
    
    $tpl->parse("ROWS", "row", true);

  } //for($i = 1; $i <= $count; $i++)  

  //parse content in main template
  $tpl->parse("CONTENT", "serverrules", false);

  //parse everything and print it
  $tpl->parse("OUT", "main", false);
  $tpl->p("OUT");

?>
